var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState } from 'react';
import { VIEWS } from 'pasubot-auth-ui-shared';
import { Anchor, Button, Container, Input, Label, Message, } from './../../UI/index.js';
function MagicLink({ setAuthView = () => { }, supabaseClient, redirectTo, i18n, appearance, showLinks = false, }) {
    var _a;
    const [email, setEmail] = useState('');
    const [error, setError] = useState('');
    const [message, setMessage] = useState('');
    const [loading, setLoading] = useState(false);
    const handleMagicLinkSignIn = (e) => __awaiter(this, void 0, void 0, function* () {
        var _b, _c;
        e.preventDefault();
        setError('');
        setMessage('');
        setLoading(true);
        if (email.length === 0) {
            setError((_b = i18n === null || i18n === void 0 ? void 0 : i18n.magic_link) === null || _b === void 0 ? void 0 : _b.empty_email_address);
            setLoading(false);
            return;
        }
        const { error } = yield supabaseClient.auth.signInWithOtp({
            email,
            options: { emailRedirectTo: redirectTo },
        });
        if (error)
            setError(error.message);
        else
            setMessage((_c = i18n === null || i18n === void 0 ? void 0 : i18n.magic_link) === null || _c === void 0 ? void 0 : _c.confirmation_text);
        setLoading(false);
    });
    const labels = i18n === null || i18n === void 0 ? void 0 : i18n.magic_link;
    return (_jsx("form", Object.assign({ id: "auth-magic-link", onSubmit: handleMagicLinkSignIn }, { children: _jsxs(Container, Object.assign({ gap: "large", direction: "vertical", appearance: appearance }, { children: [_jsxs("div", { children: [_jsx(Label, Object.assign({ htmlFor: "email", appearance: appearance }, { children: labels === null || labels === void 0 ? void 0 : labels.email_input_label })), _jsx(Input, { id: "email", name: "email", type: "email", autoFocus: true, placeholder: labels === null || labels === void 0 ? void 0 : labels.email_input_placeholder, onChange: (e) => {
                                if (setError)
                                    setError('');
                                setEmail(e.target.value);
                            }, appearance: appearance })] }), _jsx(Button, Object.assign({ color: "primary", type: "submit", loading: loading, appearance: appearance }, { children: loading ? labels === null || labels === void 0 ? void 0 : labels.loading_button_label : labels === null || labels === void 0 ? void 0 : labels.button_label })), showLinks && (_jsx(Anchor, Object.assign({ href: "#auth-sign-in", onClick: (e) => {
                        e.preventDefault();
                        setAuthView(VIEWS.SIGN_IN);
                    }, appearance: appearance }, { children: (_a = i18n === null || i18n === void 0 ? void 0 : i18n.sign_in) === null || _a === void 0 ? void 0 : _a.link_text }))), message && _jsx(Message, Object.assign({ appearance: appearance }, { children: message })), error && (_jsx(Message, Object.assign({ color: "danger", appearance: appearance }, { children: error })))] })) })));
}
export { MagicLink };
